// HTML5 WebSockets server example 

#include "FiveWin.ch"
#include "hbcompat.ch"

extern hb_version, TDataBase

static oWnd, oSocket, oClient, oPP

#define MAGIC_KEY "258EAFA5-E914-47DA-95CA-C5AB0DC85B11"                   
   
//------------------------------------------------------------------------//

function Main()

   local oBar

   oPP = __pp_Init( "c:\harbour\include", "std.ch" )

   DEFINE WINDOW oWnd TITLE "HTML5 WebSockets server" ;
      MENU BuildMenu()

   DEFINE BUTTONBAR oBar OF oWnd 2007 
   
   DEFINE MSGBAR PROMPT "FWH WebSockets Server" OF oWnd 2007

   ACTIVATE WINDOW oWnd ;
      ON INIT Server()

return nil

//------------------------------------------------------------------------//

function BuildMenu()

   local oMenu
   
   MENU oMenu
      MENUITEM "About" ACTION MsgAbout( "FWH WebSockets Server", "(c) FiveTech Software 2011-12" )
   ENDMENU
   
return oMenu      

//------------------------------------------------------------------------//

function Server()

   oSocket = TSocket():New( 2000 )

   oSocket:bAccept = { | oSocket | oClient := TSocket():Accept( oSocket:nSocket ),;
                       oClient:Cargo := .F.,; //if handshake is valid
                       oClient:bRead := { | oSocket | OnRead( oSocket ) },;
                       oClient:bClose := { | oSocket | OnClose( oSocket ) } }

   oSocket:Listen()

return nil

//------------------------------------------------------------------------//

function OnRead( oSocket )

   local cData := oSocket:GetData()
   local cContext, cKey, cSend
   local cMask, cMsg := "", nMaskPos := 1, n, cAnswer, oError
   
   if ! oSocket:Cargo 
      cContext = GetContext( cData, "Sec-WebSocket-Key" )
      cKey     = hb_Base64Encode( hb_sha1( cContext + MAGIC_KEY, .t. ) ) 
      cSend    = "HTTP/1.1 101 Switching Protocols" + CRLF + ;
                        "Upgrade: websocket" + CRLF + ;
                        "Connection: Upgrade" + CRLF + ;
                        "Sec-WebSocket-Accept: " + cKey + CRLF + CRLF
      oSocket:SendData(  cSend )
      oSocket:Cargo = .T.
   else 
      cMask = SubStr( cData, 3, 4 )
      for n = 1 to Len( SubStr( cData, 7 ) )
         cMsg += Chr( nXor( Asc( SubStr( cMask, nMaskPos++, 1 ) ), Asc( SubStr( cData, 6 + n, 1 ) ) ) )
         if nMaskPos == 5
            nMaskPos = 1
         endif   
      next   
      
      TRY 
         cMsg = __pp_Process( oPP, cMsg )
         cAnswer = cValToChar( &cMsg ) 
      CATCH oError
         cAnswer = "Error: " + oError:Description
      END      

      oSocket:SendData( Chr( 129 ) + Chr( Len( cAnswer ) ) + hb_StrToUtf8( cAnswer ) )
   endif
   
return nil

//------------------------------------------------------------------------//

function OnClose( oSocket )

   MsgInfo( "Client has closed!" )

   oSocket:End()
   oSocket = NIL

return nil

//------------------------------------------------------------------------//

static function GetContext( cData, cContext )

  local nLen := Len( cContext )
  local cValue := ""
  local aLines := hb_ATokens( cData, CRLF )
  local aSubLine
  local cRow

  for each cRow in aLines
     if cContext $ cRow
        aSubLine = hb_ATokens( cRow, ":" )
        cValue = AllTrim( aSubLine[ 2 ] )
        exit
     endif
  next

return cValue

//------------------------------------------------------------------------//

function QOut( c )

return cValToChar( c )   

//------------------------------------------------------------------------//